

// Digital Material Cube 008
// FabLab Japan
// Hiroya Tanaka


// Import Mesh Library 
import toxi.geom.*;
import toxi.geom.mesh.*;
import toxi.geom.mesh.subdiv.*;
import toxi.processing.*;
import toxi.util.*;
import toxi.volume.*;
ToxiclibsSupport gfx;
WETriangleMesh mesh;

boolean mesh_display = true;
boolean voxel_display = true;
boolean wire_display = true;

// Import
import processing.opengl.*;
import javax.media.opengl.*;  
import controlP5.*;
import javax.swing.*;
import SpringGUI.*;
SpringGUI gui; 

// File IO
String getFile; 
String setFile;
String ssetFile;
String [] txtarray = null;
String txt = null;

// Field 
/*int FIELD_SIZE =  50;
int FIELD_STEP =  30;
*/

float FIELD_SIZE =  50;
float FIELD_STEP =  30;

// Camera 
float expo = 1;
float rotx, roty;
float rate = 0.01;

// Resolution of Box
int resolution = 1;

// ControlP5
ControlP5 controlP5;
Textfield tfUserName;       // テキストフィールド
String txts = "";

// Text
PFont  font;  
long   time;  

// Unlekker
import unlekker.data.*;
import unlekker.geom.*;
STL stl;
FaceList poly;
int faces; // メッシュの数

// Array 
int[][] xyarrays = new int[48][48];
int[][] yzarrays = new int[48][48];
int[][] zxarrays = new int[48][48];
int[][][] xyzarrays = new int[48][48][48];


//Array for filling the inner
int[][][] newzyx = new int[48][52][52];
int[][][] zyx = new int[48][48][48];

//Array for probability
int[][][] prob_xyz = new int[48][48][48];

//
int ratio = 4;

void setup() {
  
  setFile = ""; getFile = "";
  
  // Array初期化
    for(int k = 0; k<48; k = k + 1){
    for(int j = 0; j<48; j = j + 1){
    for(int i = 0; i<48; i = i + 1){
            xyzarrays[k][j][i] = 0; 
    }
    }
    }
    
    
//  size(640, 480, OPENGL);  
   size(640,600,OPENGL);
   //  size(800,800,OPENGL);
  gfx=new ToxiclibsSupport(this);
  controlP5 = new ControlP5(this);  
  controlP5.addButton("loadfile",1,10,45,80,19);
  controlP5.addButton("savefile",1,100,45,80,19);
  controlP5.addButton("voxelize",1,190,45,80,19);
  controlP5.addSlider("resolution",1,48,10,70,200,20);
 // controlP5.addSlider("slice",1,48,10,100,200,20);
  controlP5.addSlider("ratio",1,8,10,100,200,20);
  
  controlP5.addToggle("mesh_display",true,300,45,20,10).setMode(ControlP5.SWITCH);
  controlP5.addToggle("voxel_display",true,400,45,20,10).setMode(ControlP5.SWITCH);
  controlP5.addToggle("wire_display",true,500,45,20,10).setMode(ControlP5.SWITCH);
}


void draw() {

  background(0);
  PGraphicsOpenGL pgl = (PGraphicsOpenGL)g;  

  
  // Lighting
    ambientLight(150, 150, 150);
    directionalLight(255,255,255,-1,0,0);
    pointLight(160, 160, 160, mouseX, mouseY, 200);
    spotLight(100, 100, 100, mouseX, mouseY, 200, 0, 0, -1, PI, 2);
    
  // Camera
  if (getFile == "" && setFile == "") {
  rotx = rotx + (mouseY - pmouseY) * rate;
  roty = roty + (mouseX - pmouseX) * rate; 
  } else { 
  rotx = 0;
  roty = 0;
  expo = 1;
  }
  
    
  // FileIO
    if(getFile != ""){
    //ファイルを取り込む
    fileLoader(); 
  } 
  
  //Text
  font = createFont("Meiryo", 12);
  textFont(font);
  fill(255,255,255);
  text("voxel uniform distribution ", 10, 25); 
  
 // Zoom In and Out
if (keyPressed && keyCode==UP) { expo = expo + 0.01; }
if (keyPressed && keyCode==DOWN) { expo = expo - 0.01; }

// 中心を合わせる
  pushMatrix(); 
 // translate(320,240,200);
 translate(width/2, height/2, 300);
  rotateX(rotx); rotateY(roty); scale(expo);  
    
        // STL書き出し
    if(setFile != ""){
   beginRaw("unlekker.data.STL",setFile+".stl");
   println("start :"+setFile);
  }

  pushStyle();
  // フレームの描画
     if (wire_display == true){

  stroke(255, 255, 255);  
  FIELD_STEP = FIELD_SIZE*2/resolution;
  
  for(int k = 0; k < resolution ; k = k + 1){
    for(int j = 0; j < resolution; j = j + 1){
       for(int i = 0; i < resolution; i = i + 1){
       
          // x
          float xx = -FIELD_SIZE + FIELD_STEP*(i + 1);
          float x = -FIELD_SIZE + FIELD_STEP*(i);
          float realx = (x + xx)/2; 
          // y
          float yy = -FIELD_SIZE + FIELD_STEP*(j + 1);
          float y = -FIELD_SIZE + FIELD_STEP*(j);
          float realy = (y + yy)/2; 
          // z
          float zz = -FIELD_SIZE + FIELD_STEP*(k + 1);
          float z = -FIELD_SIZE + FIELD_STEP*(k);
          float realz = (z + zz)/2; 
        
        pushMatrix(); 
        translate(realx,realy,realz);
        noFill();
     
        box(FIELD_STEP ,FIELD_STEP ,FIELD_STEP );
        
        popMatrix();
       }
    }
  }
     }
 popStyle();
  


  
  // メッシュの描画

  
  if(poly!=null && mesh_display == true) {
    fill(255,255,255);
    noStroke();
    poly.draw(this);
  }
  

  
    // ボクセルの描画  

 if ( voxel_display == true ) {
  noStroke();
  noFill();
  int len = txts.length(); 
  int l = 0;
  
  FIELD_STEP = FIELD_SIZE*2/resolution;

  for(int k = 0; k < resolution; k = k + 1){
    for(int j = 1; j < resolution; j = j + 1){
       for(int i = 1; i < resolution; i = i + 1){
       
          //x
          float xx = -FIELD_SIZE + FIELD_STEP*(i + 1);
          float x = -FIELD_SIZE + FIELD_STEP*(i);
          float realx = (x + xx)/2; 
          //y
          float yy = -FIELD_SIZE + FIELD_STEP*(j + 1);
          float y = -FIELD_SIZE + FIELD_STEP*(j);
          float realy = (y + yy)/2; 
          //z
          float zz = -FIELD_SIZE + FIELD_STEP*(k + 1);
          float z = -FIELD_SIZE + FIELD_STEP*(k);
          float realz = (z + zz)/2; 
        
         pushMatrix();
         translate(realx,realy,realz); 
         if( 0 < xyzarrays[i][j][k] && xyzarrays[i][j][k] < ratio ) {
          fill(00,255,00,60); 
          box(FIELD_STEP,FIELD_STEP,FIELD_STEP); 
         }else if( xyzarrays[i][j][k] >= ratio){
          fill(255,00,00,60); 
          box(FIELD_STEP,FIELD_STEP,FIELD_STEP);  
         }
         

         
         popMatrix();
       }
    }
  }
 }
  popMatrix();
  
   // STL書き出し終了
  if(setFile != "") {
  endRaw();   
  setFile = "";
   println("end");
  }
  
  // α合成を有効にする
  GL gl = pgl.beginGL();
  gl.glEnable(GL.GL_BLEND);
  gl.glBlendFunc(GL.GL_SRC_ALPHA, GL.GL_ONE_MINUS_SRC_ALPHA);  
  gl.glDisable(GL.GL_DEPTH_TEST);
  pgl.endGL();
  

    // GUI コンポーネント描画のための設定
  camera();
  gl = pgl.beginGL();
  gl.glDisable(GL.GL_DEPTH_TEST);  // 深度テストを無効化
  gl.glEnable(GL.GL_BLEND);
  gl.glBlendFunc(GL.GL_SRC_ALPHA, GL.GL_ONE_MINUS_SRC_ALPHA);  
  pgl.endGL();
}


// テキストが入力された際にコールバックされるメソッド
public synchronized void textfield(String txt) {
    txts = txt; 
}


public void loadfile(int theValue) {
    getFile = getFileName();
}


public void savefile(int theValue) {
     setFile = setFileName();
}

public void voxelize(int theValue) {
  
  // メッシュの数：int faces　　
  // AABB * AABBの衝突判定をつかってみる
  

  FIELD_STEP = FIELD_SIZE*2/resolution;
  
  for(int k = 0; k < resolution; k = k + 1){
    for(int j = 0; j < resolution; j = j + 1){
       for(int i = 0; i < resolution; i = i + 1){
       
          // x
          float xx = -FIELD_SIZE + FIELD_STEP*(i + 1);
          float x = -FIELD_SIZE + FIELD_STEP*(i);
          float realx = (x+xx)/2; 
          // y
          float yy = -FIELD_SIZE + FIELD_STEP*(j + 1);
          float y = -FIELD_SIZE + FIELD_STEP*(j);
          float realy = (y+yy)/2;
       
          //z
          float zz = -FIELD_SIZE + FIELD_STEP*(k + 1);
          float z = -FIELD_SIZE + FIELD_STEP*(k);
          float realz = (z+zz)/2;
        
          

          for(int q = 0; q< poly.f.length; q= q + 1){

            PVector pv1 = new PVector (poly.f[q].v[3],poly.f[q].v[4],poly.f[q].v[5] );
            PVector pv2 = new PVector (poly.f[q].v[6],poly.f[q].v[7],poly.f[q].v[8]);
            PVector pv3 = new PVector (poly.f[q].v[9],poly.f[q].v[10],poly.f[q].v[11]);
            PVector bmin = new PVector (x,y,z);
            PVector bmax = new PVector (xx,yy,zz);       
          
            boolean preresult = preAABB(x,y,z,xx,yy,zz, min(poly.f[q].v[3],poly.f[q].v[6],poly.f[q].v[9]),min(poly.f[q].v[4],poly.f[q].v[7],poly.f[q].v[10]),min(poly.f[q].v[5],poly.f[q].v[8],poly.f[q].v[11]),
            max(poly.f[q].v[3],poly.f[q].v[6],poly.f[q].v[9]),max(poly.f[q].v[4],poly.f[q].v[7],poly.f[q].v[10]),max(poly.f[q].v[5],poly.f[q].v[8],poly.f[q].v[11]));
            boolean result;
            if (preresult == true) {  result= SPETestTriangleAABB(pv1 ,pv2,  pv3,  bmin,  bmax); } else { result =false; }
            boolean result2 = AABB(x,y,z,xx,yy,zz, min(poly.f[q].v[3],poly.f[q].v[6],poly.f[q].v[9]),min(poly.f[q].v[4],poly.f[q].v[7],poly.f[q].v[10]),min(poly.f[q].v[5],poly.f[q].v[8],poly.f[q].v[11]),
            max(poly.f[q].v[3],poly.f[q].v[6],poly.f[q].v[9]),max(poly.f[q].v[4],poly.f[q].v[7],poly.f[q].v[10]),max(poly.f[q].v[5],poly.f[q].v[8],poly.f[q].v[11]));
            
         if (result == true || result2 == true ) {      
             xyzarrays[i][j][k] = 1;  break;
         } else { 
             xyzarrays[i][j][k] = 0;  
         }
         
        
                
          }
       }
    }
    
    
  }

   

   
   //zyx[][][]を初期化
   for(int k = 0; k < resolution; k++){
     for(int j = 0; j < resolution; j++){
       for(int i = 0; i < resolution; i++){
         zyx[k][j][i] = 0; 
       }
     }
   }
    
  //newzyx[][][]を初期化
  for(int k = 0; k < resolution; k++){
    for(int j = 0; j < resolution + 4; j++){
      for(int i = 0; i < resolution + 4; i++){
        newzyx[k][j][i] = 0;
       // print(newzyx[k][j][i] + " ");
        
      }
    //  println();
    }
   // println(k);
  }
   
   
   for(int k = 0; k < resolution; k = k+1){
     for(int j = 0; j < resolution; j = j+1){
       for(int i = 0; i < resolution; i = i + 1){
         zyx[k][j][i] = xyzarrays[k][j][i];
      //   print(zyx[k][j][i] + " ");
       }
   //    println();
     }
 //    println();
   }
   

  
  //外壁を発火済みにする(1:発火済み)
  for(int k = 0; k < resolution ; k++){
    for(int j = 0; j < resolution + 4; j++){
      for(int i = 0; i < resolution + 4; i++){
        newzyx[k][j][0] = 1;
        newzyx[k][j][resolution + 4 -1] = 1;
        newzyx[k][0][i] = 1;
        newzyx[k][resolution + 4 -1][i] = 1;
        
    //    print(newzyx[k][j][i] + " ");
      }
   //   println();
    }
   // println(k);
  }
  
  //モデルの表面データを配列に格納。表面を発火済み(1)として格納。
  for(int k = 0; k < resolution; k++){
    for(int j = 0; j < resolution; j++){
      for(int i = 0; i < resolution; i++){
        newzyx[k][j+2][i+2] = zyx[k][j][i];
       
      }
    }
  }
  
    for(int k = 0; k < resolution; k++){
    for(int j = 0; j < resolution + 4; j++){
      for(int i = 0; i < resolution + 4; i++){
  
     //   print(newzyx[k][j][i] + " ");
        
      }
  //    println();
    }
 //   println(k);
  }
  
  
  //内部と外部の判定(0:未発火 3: 発火中)
  for(int k = 0; k < resolution; k++){
    
    int burned = 2;
    
    newzyx[k][1][1] = 3;
    while(burned != 0){
      burned = 0;
      for(int j = 1; j < resolution + 4 - 1; j++){
        for(int i = 1; i < resolution + 4 - 1; i++){
          
          if(newzyx[k][j][i] == 3){
            
            if(newzyx[k][j][i-1] == 0){
              newzyx[k][j][i-1] = 3;
              burned++;
            }
            
            if(newzyx[k][j-1][i] == 0){
              newzyx[k][j-1][i] = 3;
              burned++;
            }
            
            if(newzyx[k][j][i+1] == 0){
              newzyx[k][j][i+1] = 3;
              burned++;
            }
            
            if(newzyx[k][j+1][i] == 0){
              newzyx[k][j+1][i] = 3;
              burned++;
            }
          }
        }
      }
    }
  }
  
  

 
 
  //未発火を内部(1)、発火中を外部(0)にする
  for(int k = 0; k < resolution; k++){
    for(int j = 0; j < resolution + 4 ; j++){
      for(int i = 0; i < resolution + 4; i++){
        
        if(newzyx[k][j][i] == 0){
          newzyx[k][j][i] = 1;
        }
        
      /*   if(newzyx[k][j][i] == 0){
          newzyx[k][j][i] = 2;
        }
        */
        
        if(newzyx[k][j][i] == 3){
          newzyx[k][j][i] = 0;
        }
      }
    }
  }
 
 //1が格納されている配列に1〜8の整数の乱数をふる
  for(int k = 0; k < resolution; k++){
    for(int j = 0; j < resolution + 4 ; j++){
      for(int i = 0; i < resolution + 4; i++){
        
        if(newzyx[k][j][i] == 1){
          newzyx[k][j][i] = int(random(1,8));
        }
        

      }
    }
  }
 
 
 
  //newzyx[][][]をzyx[][][]に格納
  for(int k = 0; k < resolution ; k++){
    for(int j = 0; j < resolution ; j++){
      for(int i = 0; i < resolution ; i++){
        zyx[k][j][i] = newzyx[k][j+2][i+2];
       
        print(zyx[k][j][i] + " ");
  
    
      }

  println();
    }

 println(k);
  }
  
  
   for(int i = 0; i < resolution; i = i+1){
     for(int j = 0; j < resolution; j = j+1){
       for(int k = 0; k < resolution; k = k + 1){
          xyzarrays[k][j][i] = zyx[k][j][i];
         print(xyzarrays[k][j][i] + " ");
       }
       println();
     }
     println();
   }
   
   mesh_display = false;
   wire_display = false;


}

// AABBどうちの接触を調べる
public boolean preAABB(float aminx,float aminy,float aminz, float amaxx,float amaxy, float amaxz, float bminx, float bminy, float bminz, float bmaxx, float bmaxy, float bmaxz) {
  // 衝突	
  if(              aminx < bmaxx && amaxx > bminx
		&& aminy < bmaxy && amaxy > bminy
		&& aminz < bmaxz && amaxz > bminz)
	{
                //println("1a");
		return(true);
	}
  if(              bminx < amaxx && bmaxx > aminx
		&& bminy < amaxy && bmaxy > aminy
		&& bminz < amaxz && bmaxz > aminz)
	{
               // println("1b");
		return(true);
	}
 return(false);
}


public boolean AABB(float aminx,float aminy,float aminz, float amaxx,float amaxy, float amaxz, float bminx, float bminy, float bminz, float bmaxx, float bmaxy, float bmaxz) {


  // 包含
  if(              aminx < bminx && bmaxx < amaxx
		&& aminy < bminy && bmaxy < amaxy
		&& aminz < bminz && bmaxz < amaxz)
	{
		//println("2");
                return(true);
	}

	return(false);
}

// 座標 p1,p2 を通る直線と座標 p3,p4 を結ぶ線分が交差しているかを調べる
public boolean intersection(float x1, float y1, float x2, float y2, float x3, float y3, float x4, float y4){
       
    if (((x1 - x2) * (y3 - y1) + (y1 - y2) * (x1 - x3)) * ((x1 - x2) * (y4 - y1) + (y1 - y2) * (x1 - x4)) <= 0 &&
        ((x3 - x4) * (y1 - y3) + (y3 - y4) * (x3 - x1)) * ((x3 - x4) * (y2 - y3) + (y3 - y4) * (x3 - x2)) <= 0 ) {
    
            return(true); //交差する
            
            
    } 
    
    return(false); //交差しない
  
    }
    
    
    
    
